;*******************    Pic16F873A  ***********************
;     : 
;            
; ,      .   
;      .      
;   .      
;   .      -
; .        . 
 
         list p=16f873a
         include "D:\radio\mplab\p16F873a.inc" 
         __CONFIG H'3F72'
;
;**********************  *******************************
;
 
M_O_INIT     EQU 0x03         ;b'00000011'  OPTION. . .=16         
M_TA_INIT    EQU 0xDB         ;b'11011011'   -TRISA
M_TB_INIT    EQU 0x00         ;b'00000000'   -TRISB
M_TC_INIT    EQU 0x0B         ;b'00001011'   C-TRISC
M_I_INIT     EQU 0xA0         ;b'10100000'   INTCON	
Conf_ADC     EQU 0xC4	      ;b'11000100'  ADCON1
Chan_RA1     EQU 0xC9	      ;b'11001001'  ADCON0, . .RA1
Chan_RA0     EQU 0xC1	      ;b'11000001'  ADCON0, . .RA0
Chan_RA3     EQU 0xD9	      ;b'11011001'  ADCON0, . .RA3				
Bytes	     EQU 0x10	      ; Bin    BCD	(16)
PR_PWM	     EQU 0x3F         ;  ( 32 ) 
DV_Const     EQU 0x02	      ;   Ni_Cd  (20 mV/cell)		 	 	
	
;
;********************   **********************************
;
 
U_Batt	     EQU 0x00	      ; RA0,  "U"  (.  0...9)  
I_Batt	     EQU 0x01         ; RA1,  "I"  ( )
Dis_Charge   EQU 0x02         ; RA2, 1 -   ()
Rezerv	     EQU 0x03         ; RA3,  "U"  (. 0...15)
Pr_Run	     EQU 0x04	      ; RA4, 0 -   /  ()
Dis_PWM	     EQU 0x05	      ; RA5, 0 -  PWM ()
	
	                      ; RB0...RB7,    (-)

Jp_0	     EQU 0x00	      ; RC0, 10 - Ni-Cd ,   ()
Jp_1	     EQU 0x01         ; RC1, 01 - Pb_Acid ,   ()
                              ;11 - Li-Ion 
                              ;00 -  
 	                      ;(0 -  , 1 - )
PWM          EQU 0x02         ; RC2,    ()
Jp_3	     EQU 0x03         ; RC3,   1- \ 0- ()
                               
                              ; RC4...RC7,    0...15 ()  
 
;
;****************      T_Flags ********************
;

_025_Sec      EQU 0x00		 ;1 -  0,25 
_05_Sec       EQU 0x01           ;1 -  0,5 
_1_Sec	      EQU 0x02		 ;1 -  1 
_40_Sec	      EQU 0x03		 ;1 -  40 
_60_Sec	      EQU 0x04	         ;1 -  1   

;
;***************      St_Flags *************************
;
K_Pr	     EQU 0x00	         ;1 -     
W_St	     EQU 0x01		 ;1 -  , 0 = 
P_Ok	     EQU 0x02		 ;1 -     	
C_Pr	     EQU 0x03		 ;1 -   
B_Us	     EQU 0x04		 ;1 -  .  (User) 
B_Li	     EQU 0x05	         ;1 -  Li-Ion
B_Pb	     EQU 0x06		 ;1 -  Pb-Acid
B_Ni	     EQU 0x07		 ;1 -  Ni-Cd

;
;**************     Ch_Flags ******************************
;
Bat_Err	     EQU 0x00		 ;1 -  	
Scale_Fact   EQU 0x01		 ;1 -  . = 4
Equal	     EQU 0x02		 ;1 -   R_Max = R_Bat
More	     EQU 0x03		 ;1 - R_Max > R_Bat
Less	     EQU 0x04		 ;1 - R_Max < R_Bat 					
Time_Over    EQU 0x05		 ;1 -  = 0
Sign	     EQU 0x06		 ;1 -   
	
;
;**************************  ****************************************************
;


W_copy        EQU 0x20          ;  W
ST_copy       EQU 0x21          ;  STATUS  
FSR_copy      EQU 0x22          ;  FSR
PC_Latch_copy EQU 0x23          ;   PC_LATCH
St_Flags      EQU 0x24          ;  
T_Flags	      EQU 0x25	        ;  
Ch_Flags      EQU 0x26          ;   
Int_Count_L   EQU 0x27          ;   TMR0 (. ) F4
Int_Count_H   EQU 0x28          ;   TMR0 (. ) 01
Sec_Count     EQU 0x29          ; 
Min_Count_L   EQU 0x2A          ;  (. )
Min_Count_H   EQU 0x2B          ;  (. )
Ind_Nom       EQU 0x2C          ;  
Ind_Data      EQU 0x2D          ;   
U_Lsb         EQU 0x2E          ;Bin- .U (.)
U_Msb         EQU 0x2F          ;Bin- .U (.)
I_Lsb         EQU 0x30          ;Bin- .I (.)
I_Msb         EQU 0x31          ;Bin- .I (.
Dig_0	      EQU 0x32		;    Key_Scan	 
Dig_1         EQU 0x33          ;  U_. 0   
Dig_2         EQU 0x34          ;  U_. 1 
Dig_3         EQU 0x35          ;  U_. 2 
Dig_4         EQU 0x36          ;  I_. 0 
Dig_5         EQU 0x37          ;  I_. 1 
Dig_6	      EQU 0x38          ;  I_. 2 
Dig_7	      EQU 0x39	        ;  T_. 0
Dig_8         EQU 0x3A          ;  T_. 1
Dig_9         EQU 0x3B          ;  T_. 2 
Ind_On        EQU 0x3C		;   "C"

Count         EQU 0x3D          ; 
Temp          EQU 0x3E          ;8-     
H_Byte        EQU 0x3F          ;  Bin 
L_Byte        EQU 0x40          ;.  Bin
R0	      EQU 0x41	        ;  
R1	      EQU 0x42	        ;     
R2	      EQU 0x43	        ; R0
H_Temp	      EQU 0x44		;16-    
L_Temp	      EQU 0x45	

Key_Buff      EQU 0x46		; 	
Hit_Count     EQU 0x47		;   
U_Set_1	      EQU 0x48 		;   (),					    	
U_Set_2	      EQU 0x49	        ;  ()   ()  BCD - 
U_Set_3	      EQU 0x4A 
I_Set_4       EQU 0x4B
I_Set_5       EQU 0x4C
I_Set_6	      EQU 0x4D
T_Set_7       EQU 0x4E
T_Set_8       EQU 0x4F
T_Set_9	      EQU 0x50

U_Bat_Max_L   EQU 0x51		;   /   
U_Bat_Max_H   EQU 0x52		;    Bin - 
I_Bat_Max_L   EQU 0x53		;    Bin - 
I_Bat_Max_H   EQU 0x54		;
T_Bat_Max_L   EQU 0x55		;      Bin - 
T_Bat_Max_H   EQU 0x56		;
Data_EE_Adr   EQU 0x57		;   /  EEPROM
EE_Data	      EQU 0x58		;   / 
U_Bat_L	      EQU 0x59		;    (. )
U_Bat_H	      EQU 0x5A		;    (. )
I_Bat_L	      EQU 0x5B		;  
I_Bat_H	      EQU 0x5C		;
T_Bat_L       EQU 0x5D		;    
T_Bat_H	      EQU 0x5E		;
St_State      EQU 0x5F		;    HL5,,,HL9	      	     
Timer_60      EQU 0x60		;    	
Timer_40      EQU 0x61
Delay_Reg_1   EQU 0x62		;  
Delay_Reg_2   EQU 0x63		; 
Timer_Min     EQU 0x64		;    
PWM_Limit     EQU 0x65		;    
R_Max_H	      EQU 0x66		;  
R_Max_L	      EQU 0x67		;
R_Bat_H	      EQU 0x68		;
R_Bat_L	      EQU 0x69		;
U_Bat_Min_L   EQU 0x6A		; .  ()
U_Bat_Min_H   EQU 0x6B		;
I_Bat_Min_L   EQU 0x6C		; .  (m)
I_Bat_Min_H   EQU 0x6D		;		
U_Cell_Min    EQU 0x6E		; .     
Cell_Nom      EQU 0x6F		;   					
B_Type_L      EQU 0x70		;   
B_Type_H      EQU 0x71		;
U_Min         EQU 0x72		;  
Old_Bat_H     EQU 0x73		;   					
Old_Bat_L     EQU 0x74		;    	
I_Tricle      EQU 0x75		; .    Capacity
I_Finish      EQU 0x76		;       Capacity
I_Bat_Fin_L   EQU 0x77		;     (m)
I_Bat_Fin_H   EQU 0x78		;
Capacity_L    EQU 0x79		;  (mA/)
Capacity_H    EQU 0x7A
I_Part	      EQU 0x7B		;     (Capacity/I_Bat_Max)
DV_DT	      EQU 0x7C		;     1 
			
	
;
;*************************  *****************************************************
;

Inc_16	macro			; 16 -   Temp
	incf	L_Temp,f
	btfsc	STATUS,Z
	incf	H_Temp,f
	nop
	endm
					
;
;***********************************   *************************************
;

        ORG 0                   ;    'Main'
        goto     Main        
        ORG 4                   ; 
        goto     Int_Prog       

;	
;*********************    TMR0 ***********************
;

Int_Prog
        movwf   W_copy                    ; 
        movf    STATUS,w
        movwf   ST_copy
        movf    FSR,w
        movwf   FSR_copy
        bcf     STATUS,RP0		  ; 0	
	bcf     STATUS,RP1                ;
		 
	decfsz  Int_Count_L,f		  ; .   					
	goto 	End_Int			  ;    0 -   End_Int
	movlw   0xF5			  ;   -  
	movwf   Int_Count_L		  ;   

	decfsz	Int_Count_H,f		  ; c.   	
	goto	End_Int			  ;    0 -   End_Int
	movlw	0x01			  ;   - 
	movwf	Int_Count_H		  ;  

Set_05_Sec
	bsf	T_Flags,_05_Sec		  ;   " 0,5 "	

Set_40_Sec
	decfsz	Timer_40,f		  ;  40 .  ?	
	goto	Set_60_Sec		  ;,    60 
	bsf	T_Flags,_40_Sec		  ;,    " 40 "
	movlw	0x50			  ;   
	movwf	Timer_40

Set_60_Sec
	decfsz	Timer_60,f		  ;  60 .  ?	
	goto	End_Int			  ; -   End_Int
	bsf	T_Flags,_60_Sec		  ; -   " 60 "		
	movlw	0x78			  ;   
	movwf	Timer_60
	goto	End_Int	

End_Int
	incf	Ind_Nom,f		  ;  	
	movf	Ind_Nom,w
	xorlw	0x0B			  ; 11?
	bz	Port_Set		  ;,     PORTB
	movf	Ind_Nom,w		  
	xorlw	0x0C			  ; 12?
	bz	Key_Scan		  ;,    	
	call	Indicate		  ;,      Ind_Nom
Fin_Int	
        movf    FSR_copy,w                ; 
        movwf   FSR
        movf    ST_copy,w
        movwf   STATUS       
        movf    W_copy,w
	bcf     INTCON,T0IF		  ;    TMR0
        retfie

;
;**********************************   ***************************************
;

Indicate
	movlw		Dig_0		;  Dig_0
	movwf		FSR

	movf		Ind_Nom,w	;    .
	addwf		FSR,f		;     
	movf		INDF,w		;    w
	nop                      	; 
	call		Convert		;    7 - . 
	movwf		Ind_Data	; -    Ind_Data
	
Extention				; 
	movlw		0x09		;      . "T":
	subwf		Ind_Nom,w	;  9? 
	btfss		STATUS,Z
	goto		Next_Ext	;,    
	movlw		0x3F		;,   w 3F (  "0")
	subwf		Ind_Data,w	;   = 3F? 
	btfss		STATUS,Z	;
	goto		Next_Ext	;,    
	clrf		Ind_Data	;,  Ind_Data ( )

Next_Ext
	btfss		Ch_Flags,Scale_Fact		
	goto	        Range_3		; Scale Factor  -
Range_2
	movlw		0x02		;     
	subwf		Ind_Nom,w	;   
	btfsc		STATUS,Z	; 2?
	bsf		Ind_Data,7	;,   7   Ind_Data
	goto		End_Ext		;,    	
Range_3	
	movlw		0x03		;    
	subwf		Ind_Nom,w	;   
	btfsc		STATUS,Z
	bsf		Ind_Data,7
End_Ext	
	movlw		0x06		;    
	subwf		Ind_Nom,w	;  
	btfsc		STATUS,Z
	bsf		Ind_Data,7	
Port_Out
	movf		St_State,w	;  7 .  
	movwf		PORTC		;    HL5...HL9
	bsf		STATUS,RP0	; 1
	movlw		0x00		;    
	movwf		TRISB
	bcf		STATUS,RP0	; 0
	nop
	nop
	movf		Ind_Data,w	;    
	movwf		PORTB
	movf		Ind_Nom,w	;   
	call		Tab_Nom		;    PORTC
	movwf		PORTC		; .   
	
	return

;
;*****************      ********************
;        
Convert	
	addwf		PCL,f
	retlw		0x3F		;0
	retlw		0x06		;1
	retlw		0x5B		;2
	retlw		0x4F		;3
	retlw		0x66		;4
	retlw		0x6D		;5
	retlw		0x7D		;6
	retlw		0x07		;7	
	retlw		0x7F		;8
	retlw		0x6F		;9
	retlw		0x00		; 
	retlw		0xFF		;11-Key_Scan
	
;
;*************        **********************
;

Tab_Nom
	addwf		PCL,f		
	retlw		B'00001111'	; 0
	retlw		B'00011111'	; 1
	retlw		B'00101111'	; 2
	retlw		B'00111111'	; 3
	retlw		B'01001111'	; 4
	retlw		B'01011111'	; 5
	retlw		B'01101111'	; 6
	retlw		B'01111111'	; 7
	retlw		B'10001111'	; 8
	retlw		B'10011111'	; 9
	movf		St_State,w
	return

Key_Scan
	movf	  St_State,w	;     HL5...HL9
	movwf	  PORTC	
	btfsc	  St_Flags,1	;    -   
	goto	  Clr_Ind
	bsf	  STATUS,RP0	; 1
	movlw	  0xFF		;  -  
	movwf	  TRISB		;
	bcf	  STATUS,RP0	; 0
        nop
	nop
	nop		
	nop				
	bcf	  St_Flags,0	;   
	movf	  PORTB,w	;  	
	andlw	  0x3F		; 2  
	sublw	  0x3F		;    - 
	btfsc	  STATUS,Z	;   
	goto	  End_Scan	;
	bsf	  St_Flags,0	;   -   
End_Scan
	movwf	  Key_Buff	;   
	clrf	   PORTB
	bsf	  STATUS,RP0	; 1
	movlw	  0x00		;  -  
	movwf	  TRISB		;
	bcf	  STATUS,RP0	; 0
Clr_Ind
	clrf	  Ind_Nom
	goto	  Fin_Int

Port_Set
	movf		St_State,w	;     HL5...HL9
	movwf		PORTC
	btfsc		St_Flags,1	;   , 
	goto		Fin_Int		;   
	movlw	 	0x00
	movwf	        PORTB
	bsf		STATUS,RP0	; 1
	movlw		0x00		;    
	movwf		TRISB
	bcf		STATUS,RP0	; 0
	movlw	 	0xFF		;     PORTB
	movwf	        PORTB
	goto	   	Fin_Int

;
;*************       ******************
;	

Stop_PWM
	bcf	PORTA,Dis_Charge	;   RA2   3 DA1.1 
Off_PWM					; .     VT5
	btfsc	PORTC,PWM
	goto	Off_PWM			;  
	bcf	PORTA,Dis_PWM		;     PWM 
	return
		
;
;************      BCD- *********
;****     AN526  Microchip *********************
		  
B2_Bcd
	bcf	STATUS,C
	movlw	Bytes
	movwf	Count
	clrf	R0
	clrf	R1
	clrf	R2
Loop_16
	rlf	L_Byte,f
	rlf	H_Byte,f
	rlf	R2,f
	rlf	R1,f	
	rlf	R0,f
	
	decfsz	Count,f
	goto	Adj_Dec
	retlw	0x00	

Adj_Dec
	movlw	R2
	movwf	FSR
	call	Adj_Bcd
	movlw	R1
	movwf	FSR	
	call	Adj_Bcd
	movlw	R0
	movwf	FSR
	call	Adj_Bcd
	goto	Loop_16
	
Adj_Bcd
	movlw	0x03
	addwf	0,w
	movwf	Temp
	btfsc	Temp,3
	movwf	0
	movlw	0x30
	addwf	0,w
	movwf	Temp
	btfsc	Temp,7
	movwf	0
	retlw	0

;
;*****************   BCD    ***********************
;**   5-    R0, R1, R2 (. . 
;**   .  R0)   16-   H_Byte  L_Byte (. ) **
;******     AN526  Microchip ********************

BCD_Bin
	goto	  BCD_To_Bin
Mpy_10b	
	andlw	  0x0F
	addwf	  L_Byte,f
	btfsc	  STATUS,C
	incf	  H_Byte,f
Mpy_10a
	bcf	  STATUS,C
	rlf	  L_Byte,w
	movwf	  L_Temp
	
	bcf	  STATUS,C
	rlf	  L_Byte,f
	rlf	  H_Byte,f
	bcf	  STATUS,C
	rlf	  L_Byte,f
	rlf	  H_Byte,f
	bcf	  STATUS,C
	rlf	  L_Byte,f
	rlf	  H_Byte,f
	
	movwf	  L_Temp
	addwf	  L_Byte,f
	btfsc	  STATUS,C
	incf	  H_Byte,f
	movf	  H_Temp,w
	addwf	  H_Byte,f
	retlw	  0x00

BCD_To_Bin
	clrf	  H_Byte
	movf	  R0,w
	andlw	  0x0F
	movwf	  L_Byte
	call	  Mpy_10a
	swapf	  R1,w
	call	  Mpy_10b
	movf	  R1,w
	call	  Mpy_10b
	swapf	  R2,w
	call	  Mpy_10b
	movf	  R2,w
	andlw	  0x0F
	addwf	  L_Byte,f
	btfsc	  STATUS,C
	incf	  H_Byte,f  
	
	retlw	  0x00

;
;**********************    EEPROM *********************************
;

Write_EE_Mem
	
	bsf	STATUS,RP1		; 2
	bcf	STATUS,RP0
	movf	Data_EE_Adr,w		;    
	movwf	EEADR			;  EEADR
	movf	EE_Data,w		;    
	movwf	EEDATA			;  EEDATA
	bsf	STATUS,RP0		; 3
	bcf	EECON1,EEPGD		;  EEPROM 
	bsf	EECON1,WREN		; 
	bcf	INTCON,GIE		; 
	movlw	0x55			;Required sequence
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf	EECON1,WR		; 
	btfsc	EECON1,WR		;  
	goto	$-1
	bcf	EECON1,WREN
	bcf	STATUS,RP0		; 0
	bcf	STATUS,RP1
	bsf	INTCON,GIE		; 	
	return

;
;*****************    EEPROM ***************************************
;

Read_EE_Mem
	bsf	STATUS,RP1
	bcf	STATUS,RP0
	movf	Data_EE_Adr,w
	movwf	EEADR
	bsf	STATUS,RP0
	bcf	EECON1,EEPGD
	bsf	EECON1,RD
	bcf	STATUS,RP0
	movf	EEDATA,w
	bcf	STATUS,RP1
	return
	
;
;***************      *******************
;

Delay_ADC
	movlw	0x0A
Back
	addlw	0xFF
	btfss	STATUS,Z
	goto	Back
	return

;
;******************     **************************
;
	
Update_Ind	  				
	bcf	INTCON,GIE		;   
	movf	U_Set_1,w		;    / 				
	movwf	Dig_1
	movf	U_Set_2,w						
	movwf	Dig_2
	movf	U_Set_3,w				
	movwf	Dig_3
	movf	I_Set_4,w
	movwf	Dig_4					
	movf	I_Set_5,w						
	movwf	Dig_5
	movf	I_Set_6,w						
	movwf	Dig_6
	movf	T_Set_7,w				
	movwf	Dig_7
	movf	T_Set_8,w						
	movwf	Dig_8
	movf	T_Set_9,w
	movwf	Dig_9						
	bsf	INTCON,GIE
	retlw	0x00	

;
;********************    *************************************
;*******************     ********************************
;

U_Sense
	call	Delay_ADC		;   		
	bsf	STATUS,RP0		; 1
	movlw	Conf_ADC		; .  ADCON1
	movwf	ADCON1
	bcf	STATUS,RP0		; 0

First_Mes
	movlw	Chan_RA3		; .  ADCON0 (.RA3)
	movwf	ADCON0
	call	Delay_ADC		;   
	bcf	INTCON,GIE		; 		       	 		
        bsf	ADCON0,2		;  GO/DONE

	btfsc	ADCON0,2		; 
	goto	$-1			;   
	movf	ADRESH,w		; .  
	movwf	U_Msb
	bsf	STATUS,RP0		; 1
	movf	ADRESL,w		; .
	bcf	STATUS,RP0		; 0
	movwf	U_Lsb	
	bsf	INTCON,GIE		; 	
		
Scale_F
	movf	U_Msb,w			;   		
	movwf	R_Max_H		
	movf	U_Lsb,w			
	movwf	R_Max_L			

	movlw	0x00
	movwf	R_Bat_H
	movlw	0xFA
	movwf	R_Bat_L

	call	Compare_16
	btfsc	Ch_Flags,Less		;  < 00FA?
	goto	Second_Mes		;,    1   .= 1
	 
	bsf	Ch_Flags,Scale_Fact	;,   .= 4
	bcf	STATUS,C		;    4
	rlf	U_Lsb,f
	rlf	U_Msb,f
	rlf	U_Lsb,f
	rlf	U_Msb,f
	movf	U_Lsb,w
	movwf	U_Bat_L			; .    
	movf	U_Msb,w
	movwf	U_Bat_H			; .    	
	goto	U_Conv
	
Second_Mes
	bcf	Ch_Flags,Scale_Fact		
	movlw	Chan_RA0		; .  ADCON0 (.RA0)
	movwf	ADCON0
	call	Delay_ADC		;   
	bcf	INTCON,GIE		; 		       	 		
        bsf	ADCON0,2		;  GO/DONE

	btfsc	ADCON0,2		; 
	goto	$-1 			;   
	movf	ADRESH,w		; .  
	movwf	U_Msb
	movwf	U_Bat_H			; .     
	bsf	STATUS,RP0		; 1
	movf	ADRESL,w		; .
	bcf	STATUS,RP0		; 0
	movwf	U_Lsb
	movwf	U_Bat_L			; .    		
	bsf	INTCON,GIE		; 

U_Conv
	movf	U_Msb,w			;  .
	movwf	H_Byte			;   
	movf	U_Lsb,w
	movwf	L_Byte
	call	B2_Bcd			;  

Use_Scale_Fact
	btfsc	Ch_Flags,Scale_Fact	;    RA3,  
	goto	Scale_Conv		;    10    .
		
	movlw	0x0F			;   
	andwf	R2,w			; 
	movwf	U_Set_1

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	U_Set_2

	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_3	
	goto	End_U_Conv

Scale_Conv				
	movlw	0x0F			;   1 . 
	andwf	R2,w			;   
	movwf	Dig_0			;

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	U_Set_1

	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_2

	swapf	R1,f
	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_3
	
End_U_Conv
	clrf	Dig_0
	return

;
;**********************    **********************************
;

I_Sense					
	call	Delay_ADC		;   
	bsf	STATUS,RP0		; 1
	movlw	Conf_ADC		; .  ADCON1
	movwf	ADCON1
	bcf	STATUS,RP0		; 0
	movlw	Chan_RA1		; .  ADCON0 (.RA1)
	movwf	ADCON0
	call	Delay_ADC		;   
	bcf	INTCON,GIE		; 		       	 		
        bsf	ADCON0,2		;  GO/DONE

	btfsc	ADCON0,2		; 
	goto	$-1			;   
	movf	ADRESH,w		; .  
	movwf	I_Msb
	movwf	I_Bat_H			;
	bsf	STATUS,RP0		; 1
	movf	ADRESL,w		; .
	bcf	STATUS,RP0		; 0
	movwf	I_Lsb
	movwf	I_Bat_L	 		;	
	bsf	INTCON,GIE		; 

	movf	I_Bat_L,w		;    
	movwf	L_Byte
	movf	I_Bat_H,w
	movwf	H_Byte

	bcf	STATUS,C		;  2   
	rrf	H_Byte,f
	rrf	L_Byte,f
	call	B2_Bcd

	movlw	0x0F			;     I
	andwf	R2,w		
	movwf	I_Set_4

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	I_Set_5

	movlw	0x0F
	andwf	R1,w
	movwf	I_Set_6

	return

   
;
;*************************   *******************
;                                            
Main 
	bcf       STATUS,RP1		;1
	bsf       STATUS,RP0		;
	movlw	  M_O_INIT              ; OPTION
	movwf	  OPTION_REG
	movlw     M_I_INIT		; INTCON
	movwf     INTCON
	clrf      PIE1			; .  
	clrf      PIE2                  ;  

Init_Ports
	movlw     M_TA_INIT             ; TRISA
	movwf     TRISA
	movlw     M_TB_INIT             ; TRISB
	movwf     TRISB
        movlw     M_TC_INIT             ; TRISC
	movwf     TRISC
	bcf       STATUS,RP0            ; 0
	clrf      PORTA                 ;    
        clrf      PORTB                 ;    
	clrf	  PORTC			;   

Init_TMR0
        clrf      TMR0                  ;  TMR0

Init_PWM
	bsf	  STATUS,RP0		; 1
	movlw	  PR_PWM		;   PWM
	movwf	  PR2
	bcf	  STATUS,RP0		; 0
	clrf	  CCPR1L		;   
	clrf	  CCPR1H
	movlw	  0x0F			;  
	movwf	  CCP1CON
	movlw	  0x04			; TMR2
	movwf	  T2CON
	
Init_AD
	bsf	  STATUS,RP0		; 1
	movlw	  Conf_ADC		; . ADC
	movwf	  ADCON1
	bcf	  STATUS,RP0		; 0
	clrf	  ADCON0		; ADCON0

Clear_RAM
	movlw	0x24		; Start at RAM Location 0x24
	movwf	FSR		; Use Indirect Addressing
loop:
	clrf	INDF		; Clear Location
	incf	FSR,F		; INCF to Next Location
	btfss	FSR,7		; Check for BANK 0 Done
	goto	loop

	movlw	0xA1		; Start at RAM Location 0xA1
	movwf	FSR		; Use Indirect Addressing
loop1:
	clrf	INDF		; Clear Location
	incfsz	FSR,F		; INCF to Next Location and Check for BANK 1 Done
	goto	loop1
	nop
	call	Stop_PWM	;      
				; ,   ,    - 0 
Int_Setup
	bcf	INTCON,GIE	; 
	movlw 	0x01		;      
 	movwf 	Int_Count_H	;     
	movlw 	0xF5		;    
	movwf 	Int_Count_L	;     
	
Timer_Setup
	movlw	0x78
	movwf	Timer_60
	movlw	0x50
	movwf	Timer_40
	
	bsf	INTCON,GIE	; 

	

;**********************        ****************

Read_Mem
	clrf	Data_EE_Adr	;  EEPROM   00, 01 
	call	Read_EE_Mem	;   U_Bat_Max
	movwf	U_Bat_Max_L	

	incf	Data_EE_Adr,f	
	call	Read_EE_Mem	
	movwf	U_Bat_Max_H
	
	incf	Data_EE_Adr,f	;  EEPROM   02, 03 
	call	Read_EE_Mem	;   I_Bat_Max
	movwf	I_Bat_Max_L

	incf	Data_EE_Adr,f
	call	Read_EE_Mem
	movwf	I_Bat_Max_H

	incf	Data_EE_Adr,f	;  EEPROM   04, 05 
	call	Read_EE_Mem	;   T_Bat_Max
	movwf	T_Bat_Max_L

	incf	Data_EE_Adr,f
	call	Read_EE_Mem
	movwf	T_Bat_Max_H

	incf	Data_EE_Adr,f
	call	Read_EE_Mem
	movwf	Ch_Flags
		xorlw	0xFF
		btfsc	STATUS,Z
		clrf	Ch_Flags
	

;***************   BCD      ***************************

Convert_U
	movf	U_Bat_Max_L,w	;    
	movwf	L_Byte
	movf	U_Bat_Max_H,w
	movwf	H_Byte
	call	B2_Bcd

	btfsc	Ch_Flags,Scale_Fact
	goto	Div_10

	movlw	0x0F		;     U
	andwf	R2,w		
	movwf	U_Set_1

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	U_Set_2

	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_3

	goto	Convert_I

Div_10
	swapf	R2,f
	movlw	0x0F		;  U/10    
	andwf	R2,w		
	movwf	U_Set_1
	
	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_2

	swapf	R1,f
	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_3	

Convert_I
	movf	I_Bat_Max_L,w	;    
	movwf	L_Byte
	movf	I_Bat_Max_H,w
	movwf	H_Byte
	call	B2_Bcd

	movlw	0x0F		;     I
	andwf	R2,w		
	movwf	I_Set_4

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	I_Set_5

	movlw	0x0F
	andwf	R1,w
	movwf	I_Set_6	

Convert_T
	movf	T_Bat_Max_L,w	;    
	movwf	L_Byte
	movf	T_Bat_Max_H,w
	movwf	H_Byte
	call	B2_Bcd

	movlw	0x0F		;    
	andwf	R2,w		
	movwf	T_Set_7

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	T_Set_8

	movlw	0x0F
	andwf	R1,w
	movwf	T_Set_9

	call 	Update_Ind		;   
						
;
;************************  3  ***************************************************
;
	
Delay_3s
	movlw	0x06
	movwf	Temp 
D_Loop					; 3 
	btfss	T_Flags,_05_Sec
	goto	$-1
	bcf	T_Flags,_05_Sec
	decf	Temp,f
	btfss	STATUS,Z
	goto	D_Loop
	nop


;
;***********************    *******************************
;
Setting
	call	  Stop_PWM      ;      	
	call	  U_Sense	;     
	call	  Update_Ind

Error_Check				
	call	  Bat_Check		;   
	btfss	  Ch_Flags,Bat_Err	;  U_Bat = 0,   Bat_Error
	goto	  Exit_Error
	
Bat_Error 		
	movlw	  0xEF			;  HL5 "Bat Error"
	movwf	  St_State
	goto	  Setting

Exit_Error
	nop

HL8_On
	movlw	0xBF			;  HL8 ""
	movwf	St_State
	bcf	St_Flags,1
 
;
;*************************   . Start ***********************************
;

Read_Start_Key
	nop			;   "Start"
	btfsc	  PORTA,Pr_Run  ;
	goto	  Par_Set	;  -    
	goto	  Bin_Param	; , (PortA,4=0) -    

;
;*********************       **************************
;
		
Bin_Param			
	nop

Set_Umax				; . .      
	clrf	  R0			;    
	clrf	  R1			;  
	clrf	  R2			;
	movf	  U_Set_1,w		; 3-  .  U_Set 
	andlw	  0x0F			;   R2...R0     
	movwf	  R2			; Bin  
	swapf	  U_Set_2,w
	andlw	  0xF0 			;
	addwf	  R2,f			; 
	movf	  U_Set_3,w		;
	andlw	  0x0F			; 
	movwf	  R1
	call	  BCD_Bin		;   
	movf	  L_Byte,w		;    
	movwf	  U_Bat_Max_L		;       
	movf	  H_Byte,w
	movwf	  U_Bat_Max_H
	btfsc	  Ch_Flags,Scale_Fact	;   .
	goto	  Multy_10		; . .  -  U_Bat_Max  10
	nop
	goto	  Set_I_Max

Multy_10
	movf	  U_Bat_Max_H,w  	;     10
	movwf	  R_Bat_H
	movf	  U_Bat_Max_L,w
	movwf	  R_Bat_L
	movlw	  0x09
	movwf	  Count
Plus_Byte
	movf	  R_Bat_H,w
	addwf	  U_Bat_Max_H,f
	movf	  R_Bat_L,w
	addwf	  U_Bat_Max_L,f
	btfsc	  STATUS,C
	incf	  U_Bat_Max_H,f
	decf	  Count,f
	btfss	  STATUS,Z
	goto      Plus_Byte
	goto	  Set_I_Max	
		
Set_I_Max				; .       
	clrf	  R0			;    
	clrf	  R1			;  
	clrf	  R2			; 
	movf	  I_Set_4,w		; 3-  .  I_Set 
	andlw	  0x0F			;   R2...R0     
	movwf	  R2			; Bin  
	swapf	  I_Set_5,w
	andlw	  0xF0 			;
	addwf	  R2,f			; 
	movf	  I_Set_6,w		;
	andlw	  0x0F				; 
	movwf	  R1
	call	  BCD_Bin		;   
	movf	  L_Byte,w		;    
	movwf	  I_Bat_Max_L		;       
	movf	  H_Byte,w
	movwf	  I_Bat_Max_H
	nop	

Set_Tmax				; . .      
	clrf	  R0			;    
	clrf	  R1			;  
	clrf	  R2			; 
	movf	  T_Set_7,w		; 3-  .  T_Set 
	andlw	  0x0F			;   R2...R0     
	movwf	  R2			; Bin  
	swapf	  T_Set_8,w
	andlw	  0xF0 			;
	addwf	  R2,f			; 
	movf	  T_Set_9,w		;
	andlw	  0x0F			; 
	movwf	  R1
	call	  BCD_Bin		;   
	movf	  L_Byte,w		;    
	movwf	  T_Bat_Max_L		;       
	movf	  H_Byte,w
	movwf	  T_Bat_Max_H
	nop


;**************       ************************

Write_Mem
	clrf	  Data_EE_Adr		;     00
	movf	  U_Bat_Max_L,w		;  U_Bat_Max_L
	movwf	  EE_Data		;
	call	  Write_EE_Mem		;

	incf	  Data_EE_Adr,f		;     01
	movf	  U_Bat_Max_H,w		; U_Bat_Max_H
	movwf	  EE_Data		;
	call	  Write_EE_Mem		;

	incf	  Data_EE_Adr,f		;     02
	movf	  I_Bat_Max_L,w		; I_Bat_Cr_L
	movwf	  EE_Data		;
	call	  Write_EE_Mem		;
	  
	incf	  Data_EE_Adr,f		;     03
	movf	  I_Bat_Max_H,w		; I_Bat_Cr_H
	movwf	  EE_Data		;
	call	  Write_EE_Mem		;

	incf	  Data_EE_Adr,f		;     04
	movf	  T_Bat_Max_L,w		; T_Bat_Max_L
	movwf	  EE_Data		;
	call	  Write_EE_Mem		;
	
	incf	  Data_EE_Adr,f		;     05
	movf	  T_Bat_Max_H,w		; T_Bat_Max_H
	movwf	  EE_Data		;
	call	  Write_EE_Mem		;

	incf	  Data_EE_Adr,f		;     05
	movf	  Ch_Flags,w		; Ch_Flags
	movwf	  EE_Data		;
	call	  Write_EE_Mem		;

	goto	  Begin_Process		; 

;*********************     *************************************************

Par_Set					;
	bcf	  INTCON,GIE		; 
	movlw	  0x0B			;  Dig_0  11   
	movwf	  Dig_0
	bsf	  INTCON,GIE		; 
	btfss	  St_Flags,0		;     -
	goto	  Read_Start_Key	; 

;*****************    ******************************************

Read_Key
	movf	  Key_Buff,w
	xorlw	  0x01
	bz	  Key_1

	movf	  Key_Buff,w
	xorlw	  0x02
	bz	  Key_2
	
	movf	  Key_Buff,w
	xorlw	  0x04
	bz	  Key_3

	movf	  Key_Buff,w
	xorlw	  0x08
	bz	  Key_4

	movf	  Key_Buff,w
	xorlw	  0x10
	bz	  Key_5

	movf	  Key_Buff,w
	xorlw	  0x20
	bz	  Key_6 

	goto	  Read_Start_Key
	

Key_1
	btfsc	  Ch_Flags,Scale_Fact	;  
	goto	  Key_11		; .  ,   

	clrf	  Key_Buff	
	incf	  Hit_Count,f		;  
	btfss	  Hit_Count,3		;   < 8 ( 0,256 ) -
	goto	  Read_Key		;  ,  -   , 
	clrf	  Hit_Count		;   ,
	incf	  U_Set_1,f		;    U_Set   
	movf	  U_Set_1,w		;   ,  U_Set_1 < 10,
	xorlw	  0x0A			;   U_Set_1   Dig_1. 
	btfss	  STATUS,Z		; U_Set_1 = 10 - 
	goto	  Write_Ind
	clrf	  U_Set_1		;  U_Set_1, 
	incf	  U_Set_2,f		;   U_Set_2, 
	movf	  U_Set_2,w		;
	xorlw	  0x0A			;    10
	btfss	  STATUS,Z
	goto	  Write_Ind		;   U_Set_2   Dig_2
	clrf	  U_Set_2		;,      
	goto	  Write_Ind

Key_11
	clrf	  Key_Buff
	incf	  Hit_Count,f		;  
	btfss	  Hit_Count,3		;   < 8 ( 0,256 ) -
	goto	  Read_Key		;  ,  -   , 
	clrf	  Hit_Count		;   ,
	incf	  U_Set_1,f		;    U_Set   
	movf	  U_Set_1,w		;   ,  U_Set_1 < 10,
	xorlw	  0x0A			;   U_Set_1   Dig_1. 
	btfss	  STATUS,Z		; U_Set_1 = 10, - 
	goto	  Write_Ind		;
	clrf	  U_Set_1		;      Dig_1
	goto	  Write_Ind
	
Key_2
	btfsc	  Ch_Flags,Scale_Fact	;  
	goto	  Key_21		; .  ,   

	clrf	  Key_Buff
	incf	  Hit_Count,f		;  
	btfss	  Hit_Count,3		;   < 8 ( 0,256 ) -
	goto	  Read_Key		;  ,  -   , 
	clrf	  Hit_Count		;   ,
	incf	  U_Set_3,f		;    U_Set   
	movf	  U_Set_3,w		;   ,  U_Set_3 > 9,
	sublw	  0x09			;
	btfsc   STATUS,C		;	 		 	
	goto	  Write_Ind		;
	bsf	  Ch_Flags,Scale_Fact	;  
	clrf	  U_Set_2		;  U_Set_2
	movlw	  0x01			;  U_Set_3  1
	movwf	  U_Set_3
	goto	  Write_Ind 	
			
	
Key_21
	clrf	  Key_Buff	
	incf	  Hit_Count,f		;  
	btfss	  Hit_Count,3		;   < 8 ( 0,256 ) -
	goto	  Read_Key		;  ,  -   , 
	clrf	  Hit_Count		;   ,
	incf	  U_Set_2,f		;    U_Set   
	movf	  U_Set_2,w		;   ,  U_Set_2 < 10,
	xorlw	  0x0A			;   U_Set_2   Dig_2. 
	btfss	  STATUS,Z		; U_Set_2 = 10 - 
	goto	  Write_Ind
	clrf	  U_Set_2		;  U_Set_2, 
	incf	  U_Set_3,f		;   U_Set_3, 
	movf	  U_Set_3,w		;
	 xorlw	  0x02			;    2
	btfss	  STATUS,Z
	goto	  Write_Ind		;   U_Set_3   Dig_3
	clrf	  U_Set_3		;,      
	clrf	  U_Set_2
	clrf	  U_Set_1
	bcf	  Ch_Flags,Scale_Fact
	goto	  Write_Ind

Key_3
	clrf	  Key_Buff
	incf	  Hit_Count,f		;  
	btfss	  Hit_Count,3		;   < 8 ( 0,256 ) -
	goto	  Read_Key		;  ,  -   , 
	clrf	  Hit_Count		;   ,
	incf	  I_Set_4,f		;    I_Set   
	movf	  I_Set_4,w		;   ,  I_Set_4 < 10,
	xorlw	  0x0A			;   I_Set_4   Dig_4. 
	btfss	  STATUS,Z		; I_Set_4 = 10 - 
	goto	  Write_Ind		;
	clrf	  I_Set_4		;  U_Set_4, 
	incf	  I_Set_5,f		;   I_Set_5, 
	movf	  I_Set_5,w		;
	xorlw	  0x0A			;    10
	btfss	  STATUS,Z		;
	goto	  Write_Ind
	clrf	  I_Set_5		;,   
	goto	  Write_Ind		;   I_Set_5   Dig_5

Key_4
	clrf	  Key_Buff
	incf	  Hit_Count,f		;  
	btfss	  Hit_Count,3		;   < 8 ( 0,256 ) -
	goto	  Read_Key		;  ,  -   , 
	clrf	  Hit_Count		;   ,
	incf	  I_Set_6,f		;    I_Set   
	movf	  I_Set_6,w		;   ,  I_Set_6 < 10,
	xorlw	  0x0A			;    10
	btfss	  STATUS,Z		;
	goto	  Write_Ind
	clrf	  I_Set_6		;,   
	goto	  Write_Ind		;   T_Set_6   Dig_6


Key_5
	clrf	  Key_Buff
	incf	  Hit_Count,f		;  
	btfss	  Hit_Count,3		;   < 8 ( 0,256 ) -
	goto	  Read_Key		;  ,  -   , 
	clrf	  Hit_Count		;   ,
	incf	  T_Set_7,f		;    T_Set   
	movf	  T_Set_7,w		;   ,  T_Set_7 < 10,
	xorlw	  0x0A			;   T_Set_7   Dig_7. 
	btfss	  STATUS,Z		; T_Set_7 = 10 - 
	goto	  Write_Ind		;	
	clrf	  T_Set_7		;  T_Set_7, 
	incf	  T_Set_8,f		;   T_Set_8, 
	movf	  T_Set_8,w		;
	xorlw	  0x0A			;    10
	btfss	  STATUS,Z		;
	goto	  Write_Ind
	clrf	  T_Set_8		;,   
	goto	  Write_Ind		;   T_Set_8   Dig_8

Key_6
	clrf	  Key_Buff
	incf	  Hit_Count,f		;  
	btfss	  Hit_Count,3		;   < 8 ( 0,256 ) -
	goto	  Read_Key		;  ,  -   , 
	clrf	  Hit_Count		;   ,
	incf	  T_Set_9,f		;    T_Set   
	movf	  T_Set_9,w		;   ,  T_Set_9 < 10,
	xorlw	  0x0A			;   T_Set_9   Dig_9. 
	btfss	  STATUS,Z		; T_Set_9 = 10, - 
	goto	  Write_Ind		;
	clrf	  T_Set_9		;      Dig_9
	goto	  Write_Ind

	
;
;*************       /  *************	
;
Write_Ind
	nop
	call	Update_Ind		;  
	bcf	St_Flags,0		;    
	goto	Read_Start_Key		;    "Start"


;		
;***********************    /  **************************
;
Begin_Process
	bsf	St_Flags,1		;   ()
	btfss	PORTC,3			;   (  )
	goto	Discharge
	goto	Charge

;
;***********************************  ****************************************
;

Discharge
	call	Stop_PWM		;  	
	clrf	T_Set_7			;   
	clrf	T_Set_8
	clrf	T_Set_9
	clrf	T_Flags			;   
	clrf	Timer_Min		;   

Disch_Cycle
	bsf	PORTA,2			; VT5 (  )
	movlw	0xDF			;  HL6 ""
	movwf	St_State		
	call	Delay_50ms		; 0,05  
	call	I_Sense			; ,    I_Set	
	btfss	T_Flags,_05_Sec		;0,5  ?
	goto	Disch_Cycle		;   -   
	bcf	T_Flags,_05_Sec		;   -   0,5 
	bcf     PORTA,2			;    VT5
	call	Delay_50ms 		; 0,05 
	call	U_Sense			; ,    U_Set
	bsf	PORTA,2			; 

	incf	Timer_Min,f		;  
	movf	Timer_Min,w		; .   w
	xorlw	0x78			; ?
	bz	Timer_Update		;,   ,   -
	call	Update_Ind		;      I  U
	goto	Disch_Control		;      

Timer_Update				
	clrf	Timer_Min		;  
	bcf	T_Flags,_05_Sec		;  0,5  
	incf	T_Bat_L,f		; 16 -   
	btfsc	STATUS,Z
	incf	T_Bat_H,f

	movf	T_Bat_L,w		;    
	movwf	L_Byte			;  Bin  BCD 
	movf	T_Bat_H,w
	movwf	H_Byte
	call	B2_Bcd

	movlw	0x0F			;   BCD     
	andwf	R2,w			;.  R2   T_Set_7	(. )	
	movwf	T_Set_7

	swapf	R2,f			;.  R2   T_Set_8	(.)
	movlw	0x0F
	andwf	R2,w
	movwf	T_Set_8

	movlw	0x0F			;.  R1   T_Set_9 ( )
	andwf	R1,w
	movwf	T_Set_9

	call	Update_Ind		;      I  U  

Disch_Control
	movf	U_Bat_Max_H,w		;     
	subwf	U_Bat_H,w		; U_Bat_H - U_Bat_Max_H   Temp  
	movwf	Temp			
	movf	U_Bat_Max_L,w		; U_Bat_L - U_Bat_Max_L   w 
	subwf	U_Bat_L,w		;
	btfss	STATUS,C		;  ?
	decf	Temp,f			;,    . 
	iorwf	Temp,w			;, : Temp=w=0?
	btfsc	STATUS,Z		;, U_Bat = U_Bat_Max, 
	goto	End_Discharge		;  
	btfsc	Temp,7			;,    . 
	goto	End_Discharge		; : U_Bat < U_Bat_Max -  
	goto	Disch_Cycle		; :U_Bat > U_Bat_Max -  

End_Discharge
	bcf	PORTA,2			;  VT5
	call	U_Sense			;    
	call	I_Sense			; 
	call	Update_Ind		;  
	
HL9_On
	movlw	0xAF			;  HL9 "Stop"
	movwf	St_State

Led_Blinking
	btfss	T_Flags,_05_Sec		;0,5  ?
	goto	$-1			;,    0,5 
	movlw	0xDF			;,   HL6 ""
	movwf	St_State
	bcf	T_Flags,_05_Sec		;    

	btfss	T_Flags,_05_Sec		;0,5  ?	
	goto	$-1			;,    0,5 
	movlw	0xAF			;,   HL9 "Stop"
	movwf	St_State		
	bcf	T_Flags,_05_Sec		;    
	goto	Led_Blinking		;:  0,5    HL6  HL9 
	

;
;*******************************************  *********************************************************
;

Charge
	nop
	movf	T_Bat_Max_L,w		; : 
	movwf	T_Bat_L			;   
	movf	T_Bat_Max_H,w		;    
	movwf	T_Bat_H
	bcf	Ch_Flags,Time_Over	;    
	call	T_Write			;    
	
	movlw	0xCF			;  HL7 ""
	movwf	St_State
	
	nop
	movlw	0x30
	movwf	PWM_Limit		;  M

Selection
	movlw	  0x0F			; .   St_Flags
	andwf	  St_Flags,f
Test_0
	btfsc	  PORTC,0		;    
	goto	  Test_1		;    S1  S2
	btfss	  PORTC,1
	goto	  User_Charge		;S1 - Set, S2 - Set 
	goto	  Pb_Charge		;S1 - Set, S2 - Open
Test_1
	btfsc	  PORTC,1
	goto	  Li_Charge		;S1 - Open, S2 - Open
	goto	  Ni_Cd_Charge		;S1 - Open, S2 - Set

;*****************************    ***********************************

Charge_Init
	bcf	PORTA,2			;   VT5
	call	U_Sense			;    
					;     
	call	Bat_Check		;  
	btfsc	Ch_Flags,Bat_Err	;    = 0 
	goto	Bat_Error		;    
	
	call	I_Sense			;   
					;    
	call	Update_Ind		;  
	bsf	PORTA,5			;  
	call	PWM_On			;  
	call	Delay_50ms		;   

	btfsc	St_Flags,4		;  User .   
	goto	I_Stab_Charge
	btfsc	St_Flags,6		;  Pb_Acid .   
	goto	I_Stab_Charge

	goto	State_Selection

				        
;********************************    *******************************************
  
State_Selection 			
	movf	U_Bat_Min_H,w		;   		
	movwf	R_Max_H		
	movf	U_Bat_Min_L,w			
	movwf	R_Max_L			

	movf	U_Bat_H,w
	movwf	R_Bat_H
	movf	U_Bat_L,w
	movwf	R_Bat_L

	call	Compare_16		;   .   
					;    
	btfsc	Ch_Flags,Equal		; U_Bat_Min = U_Bat -  
	goto	I_Stab_Charge		;    
	btfsc	Ch_Flags,More		; U_Bat_Min > U_Bat -  
	goto	Pre_Charge		;   . 
	btfsc	Ch_Flags,Less		; U_Bat_Min < U_Bat  -
	nop				;    
	goto	I_Stab_Charge

;****************************     **************************

Pre_Charge				;   I_Bat_Min   U_Bat_Min

	bcf	T_Flags,_05_Sec		;  0,5 

	call	Bat_Check		;  
	btfsc	Ch_Flags,Bat_Err	;    = 0 
	goto	Bat_Error		;    

	movf	I_Bat_Min_H,w		;    
	movwf	H_Temp
	movf	I_Bat_Min_L,w
	movwf	L_Temp
	call	I_Stab			; I_Bat_Min

	btfss	T_Flags,_05_Sec		;  0,5  -  
	goto	Pre_Charge		;   
	call	Update_Ind		;  
	btfss	T_Flags,_60_Sec		;  1 .-    
	goto	Pre_Charge		;  -  . 
	
	call	U_Metr			;    	
	call	Update_Ind		;  
	
	bcf	T_Flags,_60_Sec		;  1 
	goto	State_Selection	        ;    

;********************    ************************************************** 

I_Stab_Charge
	clrf	T_Flags			;  

Repeat_Cycle
	bcf	T_Flags,_05_Sec		;  05 Sec

	call	Bat_Check		;  
	btfsc	Ch_Flags,Bat_Err	;    = 0 
	goto	Bat_Error		;    
	
Metr_Cycle	
	movf	I_Bat_Max_H,w		;   
	movwf	H_Temp			;  
	movf	I_Bat_Max_L,w
	movwf	L_Temp

	call	I_Stab			;  

Time_Control
	btfss	T_Flags,_05_Sec		; 0,5 ? - 
	goto	Metr_Cycle		;,    
	call	Update_Ind		;,     
	btfss	T_Flags,_60_Sec		; 1 ? - 
	goto	Repeat_Cycle		;,   
	call	Time_Update		;,   
	call	T_Write			;    
	call	Update_Ind		; U, I, T
	btfsc	Ch_Flags,Time_Over	;    -  
	goto	End_Charge		;  	
	goto	Voltage_Control		;  -  
		
Voltage_Control

	movf	U_Bat_H,w		;   
	movwf	Old_Bat_H		;   Old_Bat
	movf	U_Bat_L,w
	movwf	Old_Bat_L
	
	
	call	U_Metr			;    	
	call	Update_Ind		;   

	btfss	St_Flags,7		; Ni_Cd? 
	goto	U_Compare		;,   U_Compare
	bcf	Ch_Flags,Sign		;,    
	
	call	Delta_U			;      
 
	btfsc	Ch_Flags,Sign		;   ,   
	goto	End_Charge			; 

U_Compare	
	movf	U_Bat_Max_H,w		;    
	movwf	R_Max_H			
	movf	U_Bat_Max_L,w
	movwf	R_Max_L

	movf	U_Bat_H,w
	movwf	R_Bat_H
	movf	U_Bat_L,w
	movwf	R_Bat_L

	call	Compare_16		;     () 
					; 
	btfsc	Ch_Flags,Equal		;     -  
	goto	Reg_Voltage		;      
	btfsc	Ch_Flags,More		;    -
	goto	I_Stab_Charge		;  
	btfss	Ch_Flags,Less		;    -
	nop				;      
	goto	Reg_Voltage


;********************     (U_Bat_Max = Const) *********************

Reg_Voltage

	btfsc	St_Flags,4		;  User    
	goto	End_Charge
	btfsc	St_Flags,7		;  Ni_Cd    
	goto	End_Charge

U_RV_Cycle
	clrf	T_Flags			;  

U_RVR_Cycle
	bcf	T_Flags,_05_Sec		;  05 Sec

	call	Bat_Check		;  
	btfsc	Ch_Flags,Bat_Err	;    = 0 
	goto	Bat_Error		;    
	
U_RV_Metr_Cycle
	
	movf	U_Bat_Max_H,w		;  
	movwf	H_Temp			;  
	movf	U_Bat_Max_L,w
	movwf	L_Temp

	call	U_Stab			;  

U_RV_Time_Control
	btfss	T_Flags,_05_Sec		;  0,5  -     
	goto	U_RV_Metr_Cycle		; ,     
	call	Update_Ind		;
	btfss	T_Flags,_60_Sec		;  1 .-   
	goto	U_RVR_Cycle		; ,   

	call	Time_Update
	call	T_Write
	call	Update_Ind
	btfsc	Ch_Flags,Time_Over	;    -     
	goto	End_Charge

I_Bat_Control
	call	I_Metr			;   
	call	I_Write			;  	
	call	Update_Ind

	movf	I_Bat_Fin_H,w		;   
	movwf	R_Max_H			;     
	movf	I_Bat_Fin_L,w
	movwf	R_Max_L

	movf	I_Bat_H,w
	movwf	R_Bat_H
	movf	I_Bat_L,w
	movwf	R_Bat_L

	call	Compare_16		; I_Bat  I_Bat_Fin

	btfsc	Ch_Flags,Equal		; I_Bat_Fin = I_Bat -  
	goto	Fin_Charge		;     
	btfsc	Ch_Flags,More		; I_Bat_Fin > I_Bat -
	goto	Fin_Charge		;     
	btfss	Ch_Flags,Less		; I_Bat_Fin < I_Bat -
	goto	Fin_Charge	
	goto	U_RV_Cycle	        ;  

;*********************************    ( ) ***************************************

Fin_Charge	
	goto	Fin_End			;,  
				
Fin_End
	goto	End_Charge		;  
	

;*******************************    ***************************************

End_Charge
	movlw	0xAF			;  HL9 "Stop"
	movwf	St_State

	bcf	CCP1CON,CCP1X		;  		
	bcf	CCP1CON,CCP1Y		; (   = 0)
	movlw	0x00
	movwf	CCPR1L
	bcf	PORTA,5			;  VT4  VT2
	
	call	U_Sense			;   
	call	I_Sense			;  
	call	Update_Ind		;  

Led_Blink
	btfss	T_Flags,_05_Sec		;    :
	goto	$-1			;   HL6 ("")
	movlw	0xCF			;  HL9 ("Stop")
	movwf	St_State		 
	bcf	T_Flags,_05_Sec

	btfss	T_Flags,_05_Sec
	goto	$-1
	movlw	0xAF			 
	movwf	St_State
	bcf	T_Flags,_05_Sec
	goto	Led_Blink		;
					
;********************************* User Charge ***************************************************

User_Charge
				
	bsf	St_Flags,4		;  User 
	goto	Charge_Init		 


;*************************************** Pb_Acid_Charge *****************************************

Pb_Charge

	bsf	St_Flags,6		;  Pb_Acid 
 	movlw	0x32			;   .    I_Bat_Fin
	movwf	I_Finish

	movlw	0x0A			;I_Part = Capacity/I_Bat_Max = 10/1
	movwf	I_Part
		
	call	Get_Capacity		;  : Capacity=I_Bat_Max*I_Part				

	call	Get_I_Bat_Fin		;    I_Bat_Fin = Capacity/I_Finish

	goto	Charge_Init		;   


;******************************** Ni_Cd & Ni_MH Charge ********************************************
	
	
Ni_Cd_Charge
	bsf	St_Flags,7		;  Ni_Cd 

	movlw	0x64			;  .   1  = 1 
	movwf	U_Min

	movlw	0x00
	movwf	B_Type_H		;  B_Type "140", .. 1,4   
	movlw	0x8C			; (   .  ) 
	movwf	B_Type_L

	movlw	0x0A			;   .  .  I_Bat_Min
	movwf	I_Tricle

	movlw	0x04			;I_Part = Capacity/I_Bat_Max = 4/1
	movwf	I_Part

	call	Get_Cell_Nom		;     Cell_Nom = U_Bat_Max/B_Type

	call	Get_U_Bat_Min		;  .  U_Bat_Min = U_Min*Cell_Nom
	
	call	Get_Capacity		;  				

	call	Get_I_Bat_Min		;  .  I_Bat_Min = Capacity/I_Tricle

	call	Get_DV_DT		;    DV_DT = DV_Const*Cell_Nom

	goto	Charge_Init		;   


;******************************* Li_Ion_Charge *********************************************

Li_Charge
	bsf	St_Flags,5		;  Li_Ion 

	movlw	0x5E			;  .   1  = 0,94 
	movwf	U_Min

	movlw	0x00
	movwf	B_Type_H		;  B_Type "135", .. 1,35   
	movlw	0x87			; (   .  ) 
	movwf	B_Type_L

	movlw	0x0A			;   .  .   
	movwf	I_Tricle

	movlw	0x02			;I_Part = Capacity/I_Bat_Max = 2/1
	movwf	I_Part
			
	call	Get_Cell_Nom		;     Cell_Nom = U_Bat_Max/B_Type

	call	Get_U_Bat_Min		;  .  U_Bat_Min = U_Min*Cell_Nom
					
	call	Get_Capacity		;  : Capacity = I_Bat_Max*I_Part

	call	Get_I_Bat_Min		;  .  I_Bat_Min = Capacity/I_Tricle

	clrf	I_Bat_Fin_H		;   .   
	movlw	0x05			;  : I_Bat_Fin=50 mA
	movwf	I_Bat_Fin_L
  
	goto	Charge_Init		;   


;
;**************************   *************************************
;                *****************************************


;
;***********************     ************************
;

PWM_On
	bsf	STATUS,RP0		;   
	movlw	PR_PWM
	movwf	PR2
	bcf	STATUS,RP0
	
	movlw	0x01			;  
	movwf	CCPR1L			;  
	bcf	CCP1CON,CCP1X		; .  = 0
	bcf	CCP1CON,CCP1Y
	
	movlw	0x04			; TMR2, .  1 
	movwf	T2CON

	movf	CCP1CON,w		;  
	andlw	b'00110000'
	iorlw	b'00001111'
	movwf	CCP1CON	
	return

;
;******************     ********************************
;

I_Metr
	bsf	STATUS,RP0		; 1
	movlw	Conf_ADC		; .  ADCON1
	movwf	ADCON1
	bcf	STATUS,RP0		; 0
	movlw	Chan_RA1		; .  ADCON0 (.RA1)
	movwf	ADCON0

	btfss	PORTC,2			;     
	goto    $-1			;  
	btfsc	PORTC,2
	goto	$-1
	bcf	INTCON,GIE		; 
	call	Delay_ADC		;   			       	 		
        bsf	ADCON0,2		;  GO/DONE
	btfsc	ADCON0,2		; 
	goto	$-1			;   
	movf	ADRESH,w		; .  
	movwf	I_Msb
	movwf	I_Bat_H			;
	bsf	STATUS,RP0		; 1
	movf	ADRESL,w		; .
	bcf	STATUS,RP0		; 0
	movwf	I_Lsb
	movwf	I_Bat_L	 		;	
	bsf	INTCON,GIE		; 
	return

;
;*******************        ***********
;

I_Write
	movf	I_Bat_L,w		;    
	movwf	L_Byte
	movf	I_Bat_H,w
	movwf	H_Byte
	call	B2_Bcd

	movlw	0x0F			;     I
	andwf	R2,w		
	movwf	I_Set_4

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	I_Set_5

	movlw	0x0F
	andwf	R1,w
	movwf	I_Set_6

	return	

;
;******************      **********************
;

U_Metr
	btfss	PORTC,2			;     
	goto    $-1			;  
	btfsc	PORTC,2
	goto	$-1	
	bcf	PORTA,5			;  
	call	U_Sense			; 
	btfsc	PORTC,2	
	goto	$-1
	bsf	PORTA,5			;  
	return


;
;*******************        ***********
;

T_Write
	movf	T_Bat_L,w
	movwf	L_Byte
	movf	T_Bat_H,w
	movwf	H_Byte	
	call	B2_Bcd
	movlw	0x0F			;    
	andwf	R2,w		
	movwf	T_Set_7

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	T_Set_8

	movlw	0x0F
	andwf	R1,w
	movwf	T_Set_9
	return

;
;***************    16-  *********************
;

Compare_16
	bcf	Ch_Flags,Equal		;    
	bcf	Ch_Flags,More
	bcf	Ch_Flags,Less
	movf	R_Max_H,w		
	subwf	R_Bat_H,w		
	movwf	Temp
	movf	R_Max_L,w
	subwf	R_Bat_L,w
	btfss	STATUS,C
	decf	Temp,f
	iorwf	Temp,w
	btfsc	STATUS,Z
	goto	Equal_P			;R_Max_ = R_Bat
			
	btfsc	Temp,7
	goto	More_P			;R_Max > R_Bat
	goto	Less_P			;R_Max < R_Bat
More_P
	bsf	Ch_Flags,More
	return
Less_P
	bsf	Ch_Flags,Less
	return
Equal_P
	bsf	Ch_Flags,Equal
	return

;
;************************     ***************************
;

Time_Update
	movf	T_Bat_L,w		; T_Bat	
	xorlw	0x00
	btfsc	STATUS,Z
	decf	T_Bat_H,f
	decf	T_Bat_L,f
	
	movf	T_Bat_H,w		;  
	xorlw	0x00
	btfss	STATUS,Z
	return
	movf	T_Bat_L,w
	xorlw	0x00
	btfss	STATUS,Z
	return
	bsf	Ch_Flags,Time_Over
	return


;
;*********************     *****************************
;

I_Stab
	nop
I_Reg
	nop
	
	call	I_Metr			;  
	
	movf	H_Temp,w		;
	movwf	R_Max_H
	movf	L_Temp,w
	movwf	R_Max_L
	
	movf	I_Bat_H,w		;   
	movwf	R_Bat_H
	movf	I_Bat_L,w
	movwf	R_Bat_L

	call	Compare_16		;  

	btfsc	Ch_Flags,Equal
	goto	Fix_PWM			; 
	btfsc	Ch_Flags,More		;    -
	goto	PWM_High		;   
	btfsc	Ch_Flags,Less		;    -
	goto	PWM_Down		;   

Fix_PWM
	goto	End_I_Stab

PWM_High
	incf	CCPR1L,f		;    1 
	movf	PWM_Limit,w		;  
	subwf	CCPR1L,w
	btfss	STATUS,C	
	goto	I_Reg
	movf	PWM_Limit,w		
	movwf	CCPR1L			; PWM   = 75%
	goto	End_I_Stab
		
PWM_Down
	decf	CCPR1L,f		;  
	movf	CCPR1L,w
	xorlw	0x00			; = 0,  
	btfss	STATUS,Z		;   = 1
	goto	I_Reg
	incf	CCPR1L,f
	
End_I_Stab
	call	I_Write			;     
	return


;
;****************************    ******************************
;

U_Stab

	call	Delay_ADC		;   		
	bsf	STATUS,RP0		; 1
	movlw	Conf_ADC		; .  ADCON1
	movwf	ADCON1
	bcf	STATUS,RP0		; 0

U_Reg
	btfss	PORTC,2			;     
	goto    $-1			;  
	btfsc	PORTC,2
	goto	$-1	
	bcf	PORTA,5			;  	

	btfsc	Ch_Flags,Scale_Fact	;    
	goto	U_Reg_Ch_3		;   

U_Reg_Ch_0
	movlw	Chan_RA0		; .  ADCON0 (.RA0)
	movwf	ADCON0
	call	Delay_ADC		;   
	bcf	INTCON,GIE		; 		       	 		
        bsf	ADCON0,2		;  GO/DONE

	btfsc	ADCON0,2		; 
	goto	$-1 			;   
	movf	ADRESH,w		; .  
	movwf	U_Msb
	movwf	U_Bat_H			; .     
	bsf	STATUS,RP0		; 1
	movf	ADRESL,w		; .
	bcf	STATUS,RP0		; 0
	movwf	U_Lsb
	movwf	U_Bat_L			; .    		
	bsf	INTCON,GIE		; 
					
	goto	Turn_PWM_On		; 
	
U_Reg_Ch_3
	movlw	Chan_RA3		; .  ADCON0 (.RA3)
	movwf	ADCON0
	call	Delay_ADC		;   
	bcf	INTCON,GIE		; 		       	 		
        bsf	ADCON0,2		;  GO/DONE

	btfsc	ADCON0,2		; 
	goto	$-1			;   
	movf	ADRESH,w		; .  
	movwf	U_Msb
	bsf	STATUS,RP0		; 1
	movf	ADRESL,w		; .
	bcf	STATUS,RP0		; 0
	movwf	U_Lsb	
	bsf	INTCON,GIE		; 	
		
	bcf	STATUS,C		;    4
	rlf	U_Lsb,f
	rlf	U_Msb,f
	rlf	U_Lsb,f
	rlf	U_Msb,f
	movf	U_Lsb,w
	movwf	U_Bat_L			; .    
	movf	U_Msb,w
	movwf	U_Bat_H			; .    

Turn_PWM_On					
	btfsc	PORTC,2			;  	
	goto	$-1
	bsf	PORTA,5								
			
Compare_U		
	movf	H_Temp,w		;    
	movwf	R_Max_H
	movf	L_Temp,w
	movwf	R_Max_L
	
	movf	U_Bat_H,w		
	movwf	R_Bat_H
	movf	U_Bat_L,w
	movwf	R_Bat_L

	call	Compare_16		;  

	btfsc	Ch_Flags,Equal
	goto	PWM_Ok			; 
	btfsc	Ch_Flags,More		;    -
	goto	PWM_Inc			;   
	btfsc	Ch_Flags,Less		;    -
	goto	PWM_Dec			;   

PWM_Ok
	goto	End_U_Stab

PWM_Inc
	incf	CCPR1L,f		;    1 
	movf	PWM_Limit,w		;  
	subwf	CCPR1L,w
	btfss	STATUS,C	
	goto	U_Reg
	movf	PWM_Limit,w		
	movwf	CCPR1L			; PWM   = 75%
	goto	End_U_Stab
		
PWM_Dec
	decf	CCPR1L,f		;  
	movf	CCPR1L,w
	xorlw	0x00			; = 0,  
	btfss	STATUS,Z		;   = 1
	goto	U_Reg
	incf	CCPR1L,f
	
End_U_Stab
	movf	U_Bat_H,w		;  .
	movwf	H_Byte			;   
	movf	U_Bat_L,w
	movwf	L_Byte
	call	B2_Bcd			;  

Use_Scale
	btfsc	Ch_Flags,Scale_Fact	;    RA3,  
	goto	U_Scale_Conv		;    10    .
		
	movlw	0x0F			;   
	andwf	R2,w			; 
	movwf	U_Set_1

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	U_Set_2

	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_3
	
	goto	U_Conv_End

U_Scale_Conv				
	movlw	0x0F			;   1 . 
	andwf	R2,w			;   
	movwf	Dig_0			;

	swapf	R2,f
	movlw	0x0F
	andwf	R2,w
	movwf	U_Set_1

	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_2

	swapf	R1,f
	movlw	0x0F
	andwf	R1,w
	movwf	U_Set_3
	
U_Conv_End
	return
	
;
;*************************       ***************
;******************************* Cell_Nom = U_Bat_Max / B_Type ***************************

Get_Cell_Nom				
	clrf	Count			; 	
	movf	U_Bat_Max_H,w		;    
	movwf	R_Bat_H
	movf	U_Bat_Max_L,w
	movwf	R_Bat_L

	movf	B_Type_H,w		; . B_Type = 0,  8- 
	xorlw	0x00
	bz	Sub_8

Sub_16
	movf	B_Type_H,w
	subwf	R_Bat_H,f
	movf	B_Type_L,w
	subwf	R_Bat_L,f
	btfss	STATUS,C
	decf	R_Bat_H,f
	movf	R_Bat_H,w
	xorlw	0x00
	bz	End_Div	
	incf	Cell_Nom,f
	goto	Sub_16

Sub_8
	movf	R_Bat_H,w		; . U_Bat = 0,   Exit_Loop 
	xorlw	0x00
	bz	Exit_Loop

	movf	B_Type_L,w
	subwf	R_Bat_L,f
	btfsc	STATUS,C
	goto	Count_Plus
	decf	R_Bat_H,f
Count_Plus
	incf	Count,f
	goto	Sub_8
Exit_Loop	
	movf	B_Type_L,w
	subwf	R_Bat_L,f
	btfsc	STATUS,C
	goto	Ext_Count
	movf	Count,w
	movwf	Cell_Nom
End_Div
	nop
	return
Ext_Count
	incf	Count,f
	goto	Exit_Loop

;
;***********************    .  **************************
;*************************** U_Bat_Min = U_Min * Cell_Nom *******************************

Get_U_Bat_Min
	clrf	R_Bat_L
	clrf	R_Bat_H
	movf	Cell_Nom,w
	movwf	Temp
	movlw	0x08
	movwf	Count
	movf	U_Min,w
	bcf	STATUS,C
Mpy_Loop
	rrf	Temp,f
	btfsc	STATUS,C
	addwf	R_Bat_H,f
	rrf	R_Bat_H,f
	rrf	R_Bat_L,f
	decfsz	Count,f
	goto	Mpy_Loop
	nop
	movf	R_Bat_H,w
	movwf	U_Bat_Min_H
	movf	R_Bat_L,w
	movwf	U_Bat_Min_L
	return

;
;*******************************  .  .  *******************
;********************************** I_Bat_Min = Capacity / I_Tricle ********************

Get_I_Bat_Min
				
	clrf	Count		; 
	clrf	L_Temp
	clrf	H_Temp	
	movf	Capacity_H,w	;    
	movwf	R_Bat_H
	movf	Capacity_L,w
	movwf	R_Bat_L
Subi_8
	movf	R_Bat_H,w	; . I_Bat = 0,   Div_Loop 
	xorlw	0x00
	bz	Div_Loop
		
	movf	I_Tricle,w	;  W  
	subwf	R_Bat_L,f
	btfsc	STATUS,C
	goto	C_Plus
	decf	R_Bat_H,f
C_Plus
	Inc_16	
	goto	Subi_8
Cont_Count
	Inc_16
Div_Loop	
	movf	I_Tricle,w	;  W   	
	subwf	R_Bat_L,f
	btfsc	STATUS,C
	goto	Cont_Count
	movf	L_Temp,w
	movwf	I_Bat_Min_L	;     I_Bat_Min
	movf	H_Temp,w
	movwf	I_Bat_Min_H
	nop
	return

;
;*************         *************
;************************ I_Bat_Fin = Capacity / I_Finish *******************************

Get_I_Bat_Fin
	nop
	clrf	Count		; 
	clrf	L_Temp
	clrf	H_Temp	
	movf	Capacity_H,w	;    
	movwf	R_Bat_H
	movf	Capacity_L,w
	movwf	R_Bat_L

Subif_8
	movf	R_Bat_H,w	; . I_Bat = 0,   Div_Loop 
	xorlw	0x00
	bz	F_Div_Loop
		
	movf	I_Finish,w	;  W  
	subwf	R_Bat_L,f
	btfsc	STATUS,C
	goto	F_C_Plus
	decf	R_Bat_H,f

F_C_Plus
	Inc_16
	goto	Subif_8

F_Cont_Count
	Inc_16

F_Div_Loop	
	movf	I_Finish,w	;  W   	
	subwf	R_Bat_L,f
	btfsc	STATUS,C
	goto	F_Cont_Count
	movf	L_Temp,w
	movwf	I_Bat_Fin_L	;     I_Bat_Fin
	movf	H_Temp,w
	movwf	I_Bat_Fin_H	
	nop
	return	

;
;************************  .   ***********************************
;****************************** Capacity = I_Part * I_Bat_Max *****************************

Get_Capacity	
	nop 
	clrf	Capacity_L
	clrf	Capacity_H
	movlw	0x10
	movwf	Count

	movf	I_Bat_Max_H,w		;    
	movwf	R_Bat_H
	movf	I_Bat_Max_L,w
	movwf	R_Bat_L

Mp_Loop
	rrf	I_Part,f
	btfss	STATUS,C
	goto	Mp_Skip
	
	movf	R_Bat_H,w
	addwf	Capacity_H,f
	movf	R_Bat_L,w
	addwf	Capacity_L,f
	btfsc	STATUS,C
	incf	Capacity_H,f

Mp_Skip
	bcf	STATUS,C
	rlf	R_Bat_L,f
	rlf	R_Bat_H,f
	decfsz	Count,f
	goto	Mp_Loop

	return



;
;***********************  .    *****************
;

Delta_U
	movf	Old_Bat_H,w		;   
	movwf	R_Max_H
	movf	Old_Bat_L,w
	movwf	R_Max_L

	movf	U_Bat_H,w
	movwf	R_Bat_H
	movf	U_Bat_L,w
	movwf	R_Bat_L

	call	Compare_16		;  
	bcf	Ch_Flags,Sign		;  
	btfsc	Ch_Flags,Equal		;     -  
	goto	Delta_End		;   
	btfsc	Ch_Flags,Less		;    -
	goto	Delta_End		;   
	btfss	Ch_Flags,More		;    -
	goto	Delta_End		;,   
	bsf	Ch_Flags,Sign		;,   
	movf	U_Bat_L,w		; Old_Bat_L - U_Bat_L 
	subwf	Old_Bat_L,w		;   w
	subwf	DV_DT,w			;Old_Bat_L - U_Bat_L > 20 mV * Cell_Nom?
	btfss	STATUS,C		;
	goto	Delta_End		;,     .  Sign
	bcf	Ch_Flags,Sign		;,   Sign  
		
Delta_End
	nop	
	return

;
;*************************  .   **************************
;******************************* DV_DT = DV_Const * Cell_Nom ******************************

Get_DV_DT	
	clrf	DV_DT
	movlw	DV_Const
	movwf	Count
	movf	Cell_Nom,w

Mpy_Loop_4
	addwf	DV_DT,f
	decfsz	Count,f
	goto	Mpy_Loop_4
	return	
	
;
;*************************     ********************************
;

Bat_Check
	bcf	Ch_Flags,Bat_Err	;  
	movf	U_Bat_H,w		
	xorlw	0x00			;.  U_Bat=0?
	btfss	STATUS,Z
	goto	End_Bat_Check		; ,    
	movf	U_Bat_L,w		; , 
	sublw	0x0A			;U_Bat_L <= 10 (100mV)?
	btfss	STATUS,C
	goto	End_Bat_Check		; ,    
	bsf	Ch_Flags,Bat_Err	; ,   

End_Bat_Check
	nop
	return	
		 


;	
;************************   50  ********************************
;

Delay_50ms		    	
	movlw	0x29                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      
	movwf	Delay_Reg_1

Delay_Loop
	movlw	0xFE
	movwf	Delay_Reg_2
 
Delay_Cycle
	decf	Delay_Reg_2,f
	movf	Delay_Reg_2,w
	xorlw	0x00
	bz	Cont_Delay
	goto	Delay_Cycle

Cont_Delay
	decf	Delay_Reg_1,f
	movf	Delay_Reg_1,w
	xorlw	0x00
	bz	End_Delay
	goto	Delay_Loop

End_Delay
	nop
	return
		
      END



;*****************************************  ************************************************





